#!/bin/sh
# 
# @ job_name         = run1
# @ notification     = never
# @ output           = $(jobid).log
# @ error            = $(jobid).log
# @ class            = astro
# @ job_type         = parallel
# @ node_usage       = not_shared
# @ wall_clock_limit = 12:00:00
# @ node             = 1
# @ tasks_per_node   = 4
# @ resources        = ConsumableCpus(1) ConsumableMemory(2gb) InfiniBand2(1)
# @ queue

# write host list to hosts.txt
/opt/ibmll/LoadL/full/bin/ll_get_machine_list $LOADL_STEP_ID > hosts.txt

# execute using mpirun; -np argument = tasks_per_node * node
mpirun -np 4 -hostfile hosts.txt ./ffMpi.x
