FUNCTION bvec,a,t,np=np,ez=ez,dec=dec,low=low,per=per
s=size(a) 
if (s(0) eq 3) then begin
  if (s(s(0)+1) eq 4) then v = fltarr(s(1),s(2),s(3),3,/no)
  if (s(s(0)+1) eq 5) then v = dblarr(s(1),s(2),s(3),3,/no)
  if keyword_set(np) eq 0 then begin
    if keyword_set(dec) ne 0 then begin
      tmp = swap_endian(a(5+8*t))
    endif else begin
      tmp = a(5+8*t)
    endelse
    if (keyword_set(low) eq 0  and  keyword_set(per) eq 0)then begin
      extrapolate_half_point,tmp
    endif
    v(*,*,*,0) =xup(temporary(tmp))
    if keyword_set(dec) ne 0 then begin
      tmp = swap_endian(a(6+8*t))
    endif else begin
      tmp = a(6+8*t)
    endelse
    v(*,*,*,1) =yup(tmp)
    if keyword_set(dec) ne 0 then begin
      tmp = swap_endian(a(7+8*t))
    endif else begin
      tmp = a(7+8*t)
    endelse
    v(*,*,*,2) =zup(tmp)
    if keyword_set(low) eq 0 then begin
      if keyword_set(per) eq 0 then begin
        return,v(3:s(1)-5,*,*,*)
      endif else begin
        return,v
      endelse
    endif else begin
      return,v(0:s(1)-2,*,*,*)
    end 
  endif else begin
    if keyword_set(dec) ne 0 then begin
      tmp = swap_endian(a(5+8*t))
    endif else begin
      tmp = a(5+8*t)
    endelse
    if keyword_set(low) eq 0 then begin
      extrapolate_half_point,tmp
    endif
    v(*,*,*,0) =xup(tmp)
    if keyword_set(dec) ne 0 then begin
      tmp = swap_endian(a(6+8*t))
    endif else begin
      tmp = a(6+8*t)
    endelse
    if keyword_set(low) eq 0 then begin
      extrapolate_half_point_y,tmp
    endif
    v(*,*,*,1) =yup(tmp)
    tmp = a(7+8*t)
    if keyword_set(dec) ne 0 then begin
      byteorder, tmp, /xdrtof
    endif
    if keyword_set(low) eq 0 then begin
       if keyword_set(ez) eq 0 then begin
          extrapolate_half_point_z,tmp
       endif else begin
          extrapolate_half_log_bz,tmp
       endelse
    endif
    v(*,*,*,2) =zup(tmp)
    if keyword_set(low) eq 0 then begin
      if keyword_set(per) eq 0 then begin
        return,v(3:s(1)-5,3:s(2)-5,3:s(3)-5,*)
      endif else begin
        return,v
      endelse
    endif else begin
      return,v(0:s(1)-2,0:s(2)-2,0:s(3)-2,*)
    end
  end

endif else begin ; 2D version 
  if (s(s(0)+1) eq 4) then v = fltarr(s(1),s(2),2,/no)
  if (s(s(0)+1) eq 5) then v = dblarr(s(1),s(2),2,/no)
  if keyword_set(dec) ne 0 then begin
    tmp = swap_endian(a(4+6*t))
  endif else begin
    tmp = a(4+6*t)
  endelse
  extrapolate_half_point,tmp
  v(*,*,0) =xup(temporary(tmp))
  if keyword_set(dec) ne 0 then begin
    tmp = swap_endian(a(5+6*t))
  endif else begin
    tmp = a(5+6*t)
  endelse
  v(*,*,1) =yup(tmp)
  if keyword_set(np) ne 0 then return,v(3:s(1)-5,3:s(2)-5,*)
  return,v(3:s(1)-5,*,*)
end

END
