FUNCTION ivec,a,t,center=center,np=np,fp=fp,dec=dec,low=low,per=per
s=size(a) 
if (s(0) eq 3) then begin
  if keyword_set(fp) ne 0 then begin
    i_vec = fltarr(s(1),s(2),s(3),3,/no)
  endif else begin
    if (s(s(0)+1) eq 4) then i_vec = fltarr(s(1),s(2),s(3),3,/no)
    if (s(s(0)+1) eq 5) then i_vec = dblarr(s(1),s(2),s(3),3,/no)
  end
  if keyword_set(dec) ne 0 then begin
     tmp = swap_endian(a(*,*,*,7+8*t))
  endif else begin
     tmp = a(*,*,*,7+8*t)
  endelse
  if keyword_set(fp) ne 0 then begin
    tmp = float(tmp)
  end
  i_vec(*,*,*,0) = ddydn(tmp)
  i_vec(*,*,*,1) = - ddxdn(temporary(tmp))
  if keyword_set(dec) ne 0 then begin
    tmp = swap_endian(a(*,*,*,6+8*t))
  endif else begin
    tmp = a(*,*,*,6+8*t)
  endelse
  if keyword_set(fp) ne 0 then begin
    tmp = float(tmp)
  end
  i_vec(*,*,*,2) = ddxdn(tmp)
  i_vec(*,*,*,0) = temporary(i_vec(*,*,*,0)) - ddzdn(temporary(tmp))
  if keyword_set(dec) ne 0 then begin
    tmp = swap_endian(a(*,*,*,5+8*t))
  endif else begin
    tmp = a(*,*,*,5+8*t)
  endelse
  if keyword_set(fp) ne 0 then begin
    tmp = float(tmp)
  end
  i_vec(*,*,*,1) = temporary(i_vec(*,*,*,1)) + ddzdn(tmp) 
  i_vec(*,*,*,2) = temporary(i_vec(*,*,*,2)) - ddydn(temporary(tmp))
  tmp=0
  if keyword_set(center) ne 0 then begin
    if keyword_set(per) eq 0 then begin
      if keyword_set(low) eq 0 then begin
        symmetric_full_point,    i_vec(*,*,*,0)
        extrapolate_half_point,  i_vec(*,*,*,1)
        extrapolate_half_point,  i_vec(*,*,*,2)
        if keyword_set(np) ne 0 then begin
          extrapolate_half_point_y,i_vec(*,*,*,0)
          symmetric_full_point_y,  i_vec(*,*,*,1)
          extrapolate_half_point_y,i_vec(*,*,*,2)
          extrapolate_half_point_z,i_vec(*,*,*,0)
          extrapolate_half_point_z,i_vec(*,*,*,1)
          symmetric_full_point_z,  i_vec(*,*,*,2)
        endif
      endif else begin
        I_field_correction_x,i_vec(*,*,*,1)
        I_field_correction_x,i_vec(*,*,*,2)
        if keyword_set(np) ne 0 then begin
          I_field_correction_y,i_vec(*,*,*,0)
          I_field_correction_y,i_vec(*,*,*,2)
          I_field_correction_z,i_vec(*,*,*,0)
          I_field_correction_z,i_vec(*,*,*,1)
        endif 
      endelse
    endif
  endif else begin
     if keyword_set(low) ne 0 then begin
        I_field_correction_x,i_vec(*,*,*,1)
        I_field_correction_x,i_vec(*,*,*,2)
     endif
     i_vec(*,*,*,0)=yup(zup(temporary(i_vec(*,*,*,0))))
     i_vec(*,*,*,1)=zup(xup(temporary(i_vec(*,*,*,1))))
     i_vec(*,*,*,2)=xup(yup(temporary(i_vec(*,*,*,2))))
  endelse
  if keyword_set(np) eq 0 then begin
    if keyword_set(low) eq 0 then begin
      if keyword_set(per) eq 0 then begin
        return,i_vec(3:s(1)-5,*,*,*)
      endif else begin
        return,i_vec
      endelse
    endif else begin
      if keyword_set(center) ne 0 then begin
        return,i_vec
      endif else begin
        return,i_vec(0:s(1)-2,*,*,*)
      endelse
    endelse
  endif else begin
    if keyword_set(low) eq 0 then begin
      return,i_vec(3:s(1)-5,3:s(2)-5,3:s(3)-5,*)
    endif else begin
      return,i_vec(0:s(1)-2,0:s(2)-2,0:s(3)-2,*)
    endelse
  endelse

endif else begin
  if (s(s(0)+1) eq 4) then i_vec = fltarr(s(1),s(2),/no)
  if (s(s(0)+1) eq 5) then i_vec = dblarr(s(1),s(2),/no)
  if keyword_set(dec) ne 0 then begin
    tmp = swap_endian(a(*,*,4+6*t))
  endif else begin
    tmp = a(*,*,4+6*t)
  endelse
  if keyword_set(fp) ne 0 then begin
    tmp = float(tmp)
  end
  i_vec(*,*) = -ddydn(tmp)
  if keyword_set(dec) ne 0 then begin
    tmp = swap_endian(a(*,*,5+6*t))
  endif else begin
    tmp = a(*,*,5+6*t)
  endelse
  if keyword_set(fp) ne 0 then begin
    tmp = float(tmp)
  end
  i_vec(*,*) = i_vec + ddxdn(tmp)
  extrapolate_half_point, i_vec
  ivec = xup(yup(i_vec))
  if keyword_set(np) ne 0 then return,i_vec(3:s(1)-5,3:s(2)-5)
  return,i_vec(3:s(1)-5,*)
end

END
