close,1                                                         ; make sure
openr,1,'snapshot.dat'                                          ; open for reading
m=192                                                           ; dimensions
a=assoc(1,fltarr(m,m,m))                                        ; associate file to array
window,xsize=6*m,ysize=2*m

loadct,39                                                       ; load a colortable (try also 3)
device,decompose=0                                              ; nake sure color works

if n_elements(nsnap) eq 0 then nsnap=10                         ; default, change interactively

for t=0,nsnap-1 do begin                                        ; loop, skipping boring part
  b2=sqrt(xup(a[8*t+5])^2+yup(a[8*t+6])^2+zup(a[8*t+7])^2)      ; magnetic magnitude
  tvscl,rebin(b2(*,*,m/2),2*m,2*m),0                            ; show projections
  tvscl,rebin(b2(*,m/2,*),2*m,2*m),1                            ; show projections
  tvscl,rebin(b2(m/2,*,*),2*m,2*m),2                            ; show projections
  xyouts,50,2*m-20,/device,string(t),charsize=1.5               ; text label
  wait,0.5                                                      ; wait 0.5 seconds
end

END
