FUNCTION vvec,a,t,np=np,fp=fp,dec=dec,low=low,per=per
s=size(a) & nx=s(1) & ny=s(2)
if (s(0) eq 3) then begin
  if keyword_set(fp) ne 0 then begin
    v = fltarr(s(1),s(2),s(3),3,/no)
    if keyword_set(dec) ne 0 then begin
      tmp = swap_endian(a(8*t))
      px = swap_endian(a(1+8*t))
    endif else begin
      tmp = a(8*t)
      px = a(1+8*t)
    endelse
    tmp = float(tmp)
    px  = float(px)
  endif else begin
    if (s(s(0)+1) eq 4) then v = fltarr(s(1),s(2),s(3),3,/no)
    if (s(s(0)+1) eq 5) then v = dblarr(s(1),s(2),s(3),3,/no)
    if keyword_set(dec) ne 0 then begin
      tmp = swap_endian(a(8*t))
      px = swap_endian(a(1+8*t))
    endif else begin
      tmp = a(8*t)
      px = a(1+8*t)
    endelse
  endelse
 
  if keyword_set(np) eq 0 then begin
    if keyword_set(per eq 0) then begin
      if keyword_set(low) eq 0 then begin
        extrapolate_full_point, tmp
        antisymmetric_half_point, px
      endif else begin
        px_correction, px
      endelse
    endif
    v(*,*,*,0) =xup(temporary(px))/tmp
    if keyword_set(dec) ne 0 then begin
      v(*,*,*,1) = swap_endian(a(2+8*t))
      v(*,*,*,2) = swap_endian(a(3+8*t))
    endif else begin
      v(*,*,*,1) = a(2+8*t)
      v(*,*,*,2) = a(3+8*t)
    endelse  
    if keyword_set(fp) ne 0 then begin
      v(*,*,*,1) =yup(float(v(*,*,*,1)))/tmp
      v(*,*,*,2) =zup(float(v(*,*,*,2)))/temporary(tmp)
    endif else begin
      v(*,*,*,1) =yup(v(*,*,*,1))/tmp
      v(*,*,*,2) =zup(v(*,*,*,2))/temporary(tmp)
    endelse
    
    if keyword_set(per) eq 0 then begin
      if keyword_set(low) eq 0 then begin
        return,v(3:nx-5,*,*,*)
      endif else begin
        return,v(0:nx-2,*,*,*)
      endelse
    endif else begin
      return,v
    endelse
  endif else begin
    if keyword_set(low) eq 0 then begin
      extrapolate_full_point, tmp
      extrapolate_full_point_y, tmp
      extrapolate_full_point_z, tmp
      antisymmetric_half_point, px
    endif else begin
      px_correction, px
    endelse
    v(*,*,*,0) =xup(px)/tmp
    if keyword_set(dec) ne 0 then begin
      px = swap_endian(a(2+8*t))
    endif else begin
      px = a(2+8*t)
    endelse
    if keyword_set(fp) ne 0 then begin
      px = float(px)
    endif
    if keyword_set(low) eq 0 then begin
       antisymmetric_half_point_y, px
    endif else begin
       py_correction, px
    endelse
    v(*,*,*,1) =yup(px)/tmp
    if keyword_set(dec) ne 0 then begin
      px = swap_endian(a(3+8*t))
    endif else begin
      px = a(3+8*t)
    endelse
    if keyword_set(fp) ne 0 then begin
      px = float(px)
    endif 
    if keyword_set(low) eq 0 then begin
       antisymmetric_half_point_z, px
    endif else begin
       pz_correction, px
    endelse
    v(*,*,*,2) =zup(temporary(px))/temporary(tmp)
    if  keyword_set(low) eq 0 then begin
      return,v(3:s(1)-5,3:s(2)-5,3:s(3)-5,*)
    endif else begin
      return,v(0:s(1)-2,0:s(2)-2,0:s(3)-2,*)
    endelse
  endelse

endif else begin ; 2D version
  if keyword_set(fp) ne 0 then begin
    v = fltarr(s(1),s(2),2,/no)
    if keyword_set(dec) ne 0 then begin
      tmp = swap_endian(a(6*t))
      px = swap_endian(a(1+6*t))
    endif else begin
      tmp = a(6*t)
      px = a(1+6*t)
    endelse
    tmp = float(tmp)
    px  = float(px)
  endif else begin
    if (s(s(0)+1) eq 4) then v = fltarr(s(1),s(2),2,/no)
    if (s(s(0)+1) eq 5) then v = dblarr(s(1),s(2),2,/no)
    if keyword_set(dec) ne 0 then begin
      tmp = swap_endian(a(6*t))
      px = swap_endian(a(1+6*t))
    endif else begin
      tmp = a(6*t)
      px = a(1+6*t)
    endelse
  endelse

  extrapolate_full_point, tmp
  antisymmetric_half_point, px
  v(*,*,0) =xup(temporary(px))/tmp
  if keyword_set(dec) ne 0 then begin
    v(*,*,1) = swap_endian(a(2+6*t))
  endif else begin
    v(*,*,1) = a(2+6*t)
  endelse
  if keyword_set(fp) ne 0 then begin
    v(*,*,1) =yup(float(v(*,*,1)))/tmp
  endif else begin
    v(*,*,1) =yup(v(*,*,1))/tmp
  end

  if keyword_set(np) ne 0 then return,v(3:nx-5,3:ny-5,*)
  return,v(3:nx-5,*,*)

endelse

END
